diff -r fb51f5b4aa4c trytond/model/modelsql.py
--- a/trytond/model/modelsql.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/model/modelsql.py	Mon Sep 24 20:36:36 2012 +0200
@@ -30,68 +30,70 @@
     _order_name = None  # Use to force order field when sorting on Many2One
     _history = False
 
-    def __init__(self):
-        super(ModelSQL, self).__init__()
-        self._sql_constraints = []
-        self._order = [('id', 'ASC')]
-        self._sql_error_messages = {}
+    @classmethod
+    def __setup__(cls):
+        super(ModelSQL, cls).__setup__()
+        cls._sql_constraints = []
+        cls._order = [('id', 'ASC')]
+        cls._sql_error_messages = {}
 
-        if not self._table:
-            self._table = self._name.replace('.', '_')
+        if not cls._table:
+            cls._table = cls.__name__.replace('.', '_')
 
-        assert self._table[-9:] != '__history', \
-                'Model _table %s cannot end with "__history"' % self._table
+        assert cls._table[-9:] != '__history', \
+                'Model _table %s cannot end with "__history"' % cls._table
 
-    def init(self, module_name):
-        super(ModelSQL, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(ModelSQL, cls).__register__(module_name)
 
-        if self.table_query():
+        if cls.table_query():
             return
 
         pool = Pool()
 
         # create/update table in the database
-        table = TableHandler(Transaction().cursor, self, module_name)
-        if self._history:
-            history_table = TableHandler(Transaction().cursor, self,
+        table = TableHandler(Transaction().cursor, cls, module_name)
+        if cls._history:
+            history_table = TableHandler(Transaction().cursor, cls,
                     module_name, history=True)
         timestamp_field = FIELDS['timestamp']
         integer_field = FIELDS['integer']
         logs = (
             ('create_date', timestamp_field.sql_type(None),
                 timestamp_field.sql_format, lambda *a: datetime.datetime.now(),
-                self.create_date.string),
+                cls.create_date.string),
             ('write_date', timestamp_field.sql_type(None),
-                timestamp_field.sql_format, None, self.write_date.string),
+                timestamp_field.sql_format, None, cls.write_date.string),
             ('create_uid', (integer_field.sql_type(None)[0],
              'INTEGER REFERENCES res_user ON DELETE SET NULL',),
-             integer_field.sql_format, lambda *a: 0, self.create_uid.string),
+             integer_field.sql_format, lambda *a: 0, cls.create_uid.string),
             ('write_uid', (integer_field.sql_type(None)[0],
              'INTEGER REFERENCES res_user ON DELETE SET NULL'),
-             integer_field.sql_format, None, self.write_uid.string),
+             integer_field.sql_format, None, cls.write_uid.string),
             )
         for log in logs:
             table.add_raw_column(log[0], log[1], log[2],
                     default_fun=log[3], migrate=False, string=log[4])
-        if self._history:
+        if cls._history:
             history_logs = (
                     ('create_date', timestamp_field.sql_type(None),
-                        timestamp_field.sql_format, self.create_date.string),
+                        timestamp_field.sql_format, cls.create_date.string),
                     ('write_date', timestamp_field.sql_type(None),
-                        timestamp_field.sql_format, self.write_date.string),
+                        timestamp_field.sql_format, cls.write_date.string),
                     ('create_uid', (integer_field.sql_type(None)[0],
                      'INTEGER REFERENCES res_user ON DELETE SET NULL',),
-                     integer_field.sql_format, self.create_uid.string),
+                     integer_field.sql_format, cls.create_uid.string),
                     ('write_uid', (integer_field.sql_type(None)[0],
                      'INTEGER REFERENCES res_user ON DELETE SET NULL'),
-                     integer_field.sql_format, self.write_uid.string),
+                     integer_field.sql_format, cls.write_uid.string),
                     )
             for log in history_logs:
                 history_table.add_raw_column(log[0], log[1], log[2],
                         migrate=False, string=log[3])
             history_table.index_action('id', action='add')
 
-        for field_name, field in self._columns.iteritems():
+        for field_name, field in cls._fields.iteritems():
             default_fun = None
             if field_name in (
                     'id',
@@ -104,8 +106,8 @@
                 continue
 
             if not hasattr(field, 'set'):
-                if field_name in self._defaults:
-                    default_fun = self._defaults[field_name]
+                if field_name in cls._defaults:
+                    default_fun = cls._defaults[field_name]
 
                     def unpack_wrapper(fun):
                         def unpack_result(*a):
@@ -115,7 +117,7 @@
                                 result = fun(*a)
                             except Exception:
                                 return None
-                            clean_results = self._clean_defaults(
+                            clean_results = cls._clean_defaults(
                                 {field_name: result})
                             return clean_results[field_name]
                         return unpack_result
@@ -129,7 +131,7 @@
                         FIELDS[field._type].sql_type(field),
                         FIELDS[field._type].sql_format, default_fun,
                         field_size, string=field.string)
-                if self._history:
+                if cls._history:
                     history_table.add_raw_column(field_name,
                             FIELDS[field._type].sql_type(field), None,
                             string=field.string)
@@ -159,69 +161,71 @@
                 fields.Many2Many)):
                 raise Exception('Unknow field type !')
 
-        for field_name, field in self._columns.iteritems():
+        for field_name, field in cls._fields.iteritems():
             if isinstance(field, fields.Many2One) \
-                    and field.model_name == self._name \
+                    and field.model_name == cls.__name__ \
                     and field.left and field.right:
                 with Transaction().set_user(0):
-                    self._rebuild_tree(field_name, False, 0)
+                    cls._rebuild_tree(field_name, False, 0)
 
-        for ident, constraint, _ in self._sql_constraints:
+        for ident, constraint, _ in cls._sql_constraints:
             table.add_constraint(ident, constraint)
 
-        if self._history:
-            self._update_history_table()
+        if cls._history:
+            cls._update_history_table()
             cursor = Transaction().cursor
-            cursor.execute('SELECT id FROM "' + self._table + '"')
+            cursor.execute('SELECT id FROM "' + cls._table + '"')
             if cursor.fetchone():
-                cursor.execute('SELECT id FROM "' + self._table + '__history"')
+                cursor.execute('SELECT id FROM "' + cls._table + '__history"')
                 if not cursor.fetchone():
-                    columns = ['"' + str(x) + '"' for x in self._columns
-                            if not hasattr(self._columns[x], 'set')]
+                    columns = ['"' + str(x) + '"' for x in cls._fields
+                            if not hasattr(cls._fields[x], 'set')]
                     cursor.execute('INSERT ' \
-                            'INTO "' + self._table + '__history" '\
+                            'INTO "' + cls._table + '__history" '\
                             '(' + ','.join(columns) + ') ' \
                             'SELECT ' + ','.join(columns) + \
-                            ' FROM "' + self._table + '"')
-                    cursor.execute('UPDATE "' + self._table + '__history" ' \
+                            ' FROM "' + cls._table + '"')
+                    cursor.execute('UPDATE "' + cls._table + '__history" ' \
                             'SET write_date = NULL')
 
-    def _update_history_table(self):
-        if self._history:
-            table = TableHandler(Transaction().cursor, self)
-            history_table = TableHandler(Transaction().cursor, self,
+    @classmethod
+    def _update_history_table(cls):
+        if cls._history:
+            table = TableHandler(Transaction().cursor, cls)
+            history_table = TableHandler(Transaction().cursor, cls,
                     history=True)
             for column_name in table._columns:
                 string = ''
-                if column_name in self._columns:
-                    string = self._columns[column_name].string
+                if column_name in cls._fields:
+                    string = cls._fields[column_name].string
                 history_table.add_raw_column(column_name,
-                        (table._columns[column_name]['typname'],
-                            table._columns[column_name]['typname']),
-                            None, string=string)
+                    (table._columns[column_name]['typname'],
+                        table._columns[column_name]['typname']),
+                    None, string=string)
 
-    def _get_error_messages(self):
-        res = super(ModelSQL, self)._get_error_messages()
-        res += self._sql_error_messages.values()
-        for _, _, error in self._sql_constraints:
+    @classmethod
+    def _get_error_messages(cls):
+        res = super(ModelSQL, cls)._get_error_messages()
+        res += cls._sql_error_messages.values()
+        for _, _, error in cls._sql_constraints:
             res.append(error)
         return res
 
-    def table_query(self):
+    @staticmethod
+    def table_query():
         '''
         Return None if the model is a real table in the database
         or return a tuple with the SQL query and the arguments.
-
-        :return: None or a tuple with a SQL query and arguments
         '''
         return None
 
-    def create(self, values):
-        super(ModelSQL, self).create(values)
+    @classmethod
+    def create(cls, values):
+        super(ModelSQL, cls).create(values)
         cursor = Transaction().cursor
         pool = Pool()
 
-        if self.table_query():
+        if cls.table_query():
             return False
 
         values = values.copy()
@@ -235,22 +239,22 @@
         # Get default values
         default = []
         avoid_table = []
-        for (i, j) in self._inherits.items():
+        for (i, j) in cls._inherits.items():
             if j in values:
                 avoid_table.append(i)
-        for i in self._columns.keys():
+        for i in cls._fields.keys():
             if not i in values \
                     and i not in ('create_uid', 'create_date',
                             'write_uid', 'write_date'):
                 default.append(i)
-        for i in self._inherit_fields.keys():
+        for i in cls._inherit_fields.keys():
             if ((not i in values)
-                    and (not self._inherit_fields[i][0] in avoid_table)
-                    and i in self._defaults):
+                    and (not cls._inherit_fields[i][0] in avoid_table)
+                    and i in cls._defaults):
                 default.append(i)
 
         if len(default):
-            defaults = self.default_get(default, with_rec_name=False)
+            defaults = cls.default_get(default, with_rec_name=False)
             for field in defaults.keys():
                 if '.' in field:
                     del defaults[field]
@@ -259,86 +263,78 @@
                     del defaults[field]
                 if field in values:
                     del defaults[field]
-            values.update(self._clean_defaults(defaults))
+            values.update(cls._clean_defaults(defaults))
 
         (upd0, upd1, upd2) = ('', '', [])
         upd_todo = []
 
         # Create inherits
         tocreate = {}
-        for i in self._inherits:
-            if self._inherits[i] not in values:
+        for i in cls._inherits:
+            if cls._inherits[i] not in values:
                 tocreate[i] = {}
 
         for i in values.keys():
-            if i in self._inherit_fields:
-                (inherits, _, _) = self._inherit_fields[i]
-                if i in self._columns:
+            if i in cls._inherit_fields:
+                (inherits, _, _) = cls._inherit_fields[i]
+                if i in cls._fields:
                     continue
                 if inherits in tocreate:
                     tocreate[inherits][i] = values[i]
                 del values[i]
 
         for inherits in tocreate:
-            inherits_obj = pool.get(inherits)
+            Inherits = pool.get(inherits)
             with Transaction().set_user(0, set_context=True):
-                inherits_id = inherits_obj.create(tocreate[inherits])
-            values[self._inherits[inherits]] = inherits_id
+                inherits_record = Inherits.create(tocreate[inherits])
+            values[cls._inherits[inherits]] = inherits_record.id
 
         # Insert record
-        for field in values:
-            column = self._columns[field]
-            if not hasattr(self._columns[field], 'set'):
-                upd0 = upd0 + ',"' + field + '"'
+        for fname, value in values.iteritems():
+            field = cls._fields[fname]
+            if not hasattr(field, 'set'):
+                upd0 = upd0 + ',"' + fname + '"'
                 upd1 = upd1 + ', %s'
-                upd2.append(FIELDS[self._columns[field]._type].sql_format(
-                    values[field]))
+                upd2.append(FIELDS[field._type].sql_format(value))
             else:
-                upd_todo.append(field)
-            if field in self._columns \
-                    and hasattr(self._columns[field], 'selection') \
-                    and self._columns[field].selection \
-                    and values[field]:
-                if self._columns[field]._type == 'reference':
-                    if isinstance(values[field], basestring):
-                        val = values[field].split(',')[0]
+                upd_todo.append(fname)
+            if (hasattr(field, 'selection')
+                    and field.selection
+                    and value):
+                if field._type == 'reference':
+                    if isinstance(value, basestring):
+                        value = value.split(',')[0]
                     else:
-                        val, _ = values[field]
+                        value, _ = value
+                if isinstance(field.selection, (tuple, list)):
+                    test = dict(field.selection)
                 else:
-                    val = values[field]
-                if isinstance(self._columns[field].selection, (tuple, list)):
-                    if val not in dict(self._columns[field].selection):
-                        raise Exception('ValidateError',
-                        'The value "%s" for the field "%s" ' \
-                                'is not in the selection' % \
-                                (val, field))
-                else:
-                    if val not in dict(getattr(self,
-                        self._columns[field].selection)()):
-                        raise Exception('ValidateError',
-                        'The value "%s" for the field "%s" ' \
-                                'is not in the selection' % \
-                                (val, field))
+                    test = dict(getattr(cls, field.selection)())
+                if value not in test:
+                    raise Exception('ValidateError',
+                        'The value "%s" for the field "%s" '
+                        'is not in the selection'
+                        % (value, fname))
         upd0 += ', create_uid, create_date'
         upd1 += ', %s, %s'
         upd2.append(Transaction().user)
         upd2.append(datetime.datetime.now())
         try:
             if cursor.has_returning():
-                cursor.execute('INSERT INTO "' + self._table + '" '
+                cursor.execute('INSERT INTO "' + cls._table + '" '
                     '(' + upd0[1:] + ') '
                     'VALUES (' + upd1[1:] + ') RETURNING id',
                     tuple(upd2))
                 id_new, = cursor.fetchone()
             else:
-                id_new = cursor.nextid(self._table)
+                id_new = cursor.nextid(cls._table)
                 if id_new:
-                    cursor.execute('INSERT INTO "' + self._table + '" '
+                    cursor.execute('INSERT INTO "' + cls._table + '" '
                         '(id' + upd0 + ') '
                         'VALUES (' + str(id_new) + upd1 + ')',
                         tuple(upd2))
                 else:
-                    cursor.execute('INSERT INTO "' + self._table + '" '
+                    cursor.execute('INSERT INTO "' + cls._table + '" '
                         '(' + upd0[1:] + ') '
                         'VALUES (' + upd1[1:] + ')',
                         tuple(upd2))
@@ -346,101 +342,99 @@
         except DatabaseIntegrityError, exception:
             with contextlib.nested(Transaction().new_cursor(),
                     Transaction().set_user(0)):
-                for field_name in self._columns:
-                    field = self._columns[field_name]
+                for field_name in cls._fields:
+                    field = cls._fields[field_name]
                     # Check required fields
                     if field.required and \
                             not hasattr(field, 'set') and \
                             field_name not in ('create_uid', 'create_date'):
                         if not values.get(field_name):
-                            self.raise_user_error('required_field',
-                                    error_args=self._get_error_args(
+                            cls.raise_user_error('required_field',
+                                    error_args=cls._get_error_args(
                                         field_name))
                     if isinstance(field, fields.Many2One) \
                             and values.get(field_name):
-                        model_obj = pool.get(field.model_name)
+                        Model = pool.get(field.model_name)
                         create_records = Transaction().create_records.get(
                                 field.model_name, set())
                         delete_records = Transaction().delete_records.get(
                                 field.model_name, set())
-                        if not ((model_obj.search([
-                            ('id', '=', values[field_name]),
-                            ], order=[])
-                            or values[field_name] in create_records)
-                            and values[field_name] not in delete_records):
-                            self.raise_user_error('foreign_model_missing',
-                                    error_args=self._get_error_args(
+                        if not ((Model.search([
+                                            ('id', '=', values[field_name]),
+                                            ], order=[])
+                                    or values[field_name] in create_records)
+                                and values[field_name] not in delete_records):
+                            cls.raise_user_error('foreign_model_missing',
+                                    error_args=cls._get_error_args(
                                         field_name))
-                for name, _, error in self._sql_constraints:
+                for name, _, error in cls._sql_constraints:
                     if name in exception[0]:
-                        self.raise_user_error(error)
-                for name, error in self._sql_error_messages:
+                        cls.raise_user_error(error)
+                for name, error in cls._sql_error_messages:
                     if name in exception[0]:
-                        self.raise_user_error(error)
+                        cls.raise_user_error(error)
             raise
 
-        domain1, domain2 = pool.get('ir.rule').domain_get(self._name,
+        domain1, domain2 = pool.get('ir.rule').domain_get(cls.__name__,
                 mode='create')
         if domain1:
-            cursor.execute('SELECT id FROM "' + self._table + '" ' \
+            cursor.execute('SELECT id FROM "' + cls._table + '" ' \
                     'WHERE id = %s AND (' + domain1 + ')',
                     [id_new] + domain2)
             if not cursor.fetchone():
-                self.raise_user_error('access_error', self._description)
+                cls.raise_user_error('access_error', cls.__name__)
 
-        Transaction().create_records.setdefault(self._name, set()).add(id_new)
+        Transaction().create_records.setdefault(
+            cls.__name__, set()).add(id_new)
 
         for field in values:
-            if getattr(self._columns[field], 'translate', False):
+            if getattr(cls._fields[field], 'translate', False):
                 pool.get('ir.translation').set_ids(
-                        self._name + ',' + field, 'model',
+                        cls.__name__ + ',' + field, 'model',
                         Transaction().language, [id_new], values[field])
 
         for field in upd_todo:
-            self._columns[field].set([id_new], self, field, values[field])
+            cls._fields[field].set([id_new], cls, field, values[field])
 
-        if self._history:
-            cursor.execute('INSERT INTO "' + self._table + '__history" '
+        if cls._history:
+            cursor.execute('INSERT INTO "' + cls._table + '__history" '
                 '(id' + upd0 + ') '
                 'SELECT id' + upd0 + ' '
-                'FROM "' + self._table + '" '
+                'FROM "' + cls._table + '" '
                 'WHERE id = %s', (id_new,))
 
-        self._validate([id_new])
+        record = cls(id_new)
+        cls._validate([record])
 
         # Check for Modified Preorder Tree Traversal
-        for k in self._columns:
-            field = self._columns[k]
+        for k in cls._fields:
+            field = cls._fields[k]
             if isinstance(field, fields.Many2One) \
-                    and field.model_name == self._name \
+                    and field.model_name == cls.__name__ \
                     and field.left and field.right:
-                self._update_tree(id_new, k, field.left, field.right)
+                cls._update_tree(id_new, k, field.left, field.right)
 
-        self.trigger_create(id_new)
+        cls.trigger_create(record)
 
-        return id_new
+        return record
 
-    def read(self, ids, fields_names=None):
+    @classmethod
+    def read(cls, ids, fields_names=None):
         pool = Pool()
-        rule_obj = pool.get('ir.rule')
-        translation_obj = pool.get('ir.translation')
-        super(ModelSQL, self).read(ids, fields_names=fields_names)
+        Rule = pool.get('ir.rule')
+        Translation = pool.get('ir.translation')
+        super(ModelSQL, cls).read(ids, fields_names=fields_names)
         cursor = Transaction().cursor
 
         if not fields_names:
-            fields_names = list(set(self._columns.keys() \
-                    + self._inherit_fields.keys()))
-
-        int_id = False
-        if isinstance(ids, (int, long)):
-            int_id = True
-            ids = [ids]
+            fields_names = list(set(cls._fields.keys() \
+                    + cls._inherit_fields.keys()))
 
         if not ids:
             return []
 
         # construct a clause for the rules :
-        domain1, domain2 = rule_obj.domain_get(self._name, mode='read')
+        domain1, domain2 = Rule.domain_get(cls.__name__, mode='read')
 
         fields_related = {}
         datetime_fields = []
@@ -451,27 +445,27 @@
                 field, field_related = field_name.split('.', 1)
                 fields_related.setdefault(field, [])
                 fields_related[field].append(field_related)
-            elif field_name in self._columns:
-                field = self._columns[field_name]
+            elif field_name in cls._fields:
+                field = cls._fields[field_name]
             else:
-                field = self._inherit_fields[field_name][2]
+                field = cls._inherit_fields[field_name][2]
             if hasattr(field, 'datetime_field') and field.datetime_field:
                 datetime_fields.append(field.datetime_field)
 
         # all inherited fields + all non inherited fields
         fields_pre = [x for x in \
                 fields_names + fields_related.keys() + datetime_fields \
-                if (x in self._columns and \
-                not hasattr(self._columns[x], 'set')) or \
+                if (x in cls._fields and \
+                not hasattr(cls._fields[x], 'set')) or \
                 (x == '_timestamp')] + \
-                self._inherits.values()
+                cls._inherits.values()
 
         res = []
         table_query = ''
         table_args = []
 
-        if self.table_query():
-            table_query, table_args = self.table_query()
+        if cls.table_query():
+            table_query, table_args = cls.table_query()
             table_query = '(' + table_query + ') AS '
 
         in_max = cursor.IN_MAX
@@ -479,33 +473,33 @@
         history_clause = ''
         history_limit = ''
         history_args = []
-        if (self._history
+        if (cls._history
                 and Transaction().context.get('_datetime')
                 and not table_query):
             in_max = 1
-            table_query = '"' + self._table + '__history" AS '
+            table_query = '"' + cls._table + '__history" AS '
             history_clause = ' AND (COALESCE(write_date, create_date) <= %s)'
             history_order = ' ORDER BY COALESCE(write_date, create_date) DESC'
             history_limit = cursor.limit_clause('', 1)
             history_args = [Transaction().context['_datetime']]
         if len(fields_pre):
-            fields_pre2 = ['"%s"."%s" AS "%s"' % (self._table, x, x)
+            fields_pre2 = ['"%s"."%s" AS "%s"' % (cls._table, x, x)
                     for x in fields_pre if x != '_timestamp']
             if '_timestamp' in fields_pre:
-                if not self.table_query():
+                if not cls.table_query():
                     fields_pre2 += ['CAST(EXTRACT(EPOCH FROM '
                             '(COALESCE("%s".write_date, "%s".create_date))) '
                             'AS VARCHAR) AS _timestamp' %
-                            (self._table, self._table)]
+                            (cls._table, cls._table)]
             if 'id' not in fields_pre:
-                fields_pre2 += ['"%s".id AS id' % self._table]
+                fields_pre2 += ['"%s".id AS id' % cls._table]
 
             for i in range(0, len(ids), in_max):
                 sub_ids = ids[i:i + in_max]
                 red_sql, red_ids = reduce_ids('id', sub_ids)
                 if domain1:
                     cursor.execute('SELECT ' + ','.join(fields_pre2)
-                        + ' FROM ' + table_query + '\"' + self._table + '\" '
+                        + ' FROM ' + table_query + '\"' + cls._table + '\" '
                         'WHERE ' + red_sql + history_clause +
                             ' AND (' + domain1 + ') '
                         + history_order
@@ -513,7 +507,7 @@
                         table_args + red_ids + history_args + domain2)
                 else:
                     cursor.execute('SELECT ' + ','.join(fields_pre2)
-                        + ' FROM ' + table_query + '\"' + self._table + '\" '
+                        + ' FROM ' + table_query + '\"' + cls._table + '\" '
                         'WHERE ' + red_sql + history_clause
                         + history_order
                         + history_limit,
@@ -522,7 +516,7 @@
                 if not len(dictfetchall) == len({}.fromkeys(sub_ids)):
                     if domain1:
                         cursor.execute('SELECT id '
-                            'FROM ' + table_query + '\"' + self._table + '\" '
+                            'FROM ' + table_query + '\"' + cls._table + '\" '
                             'WHERE ' + red_sql + history_clause
                             + history_order
                             + history_limit,
@@ -531,9 +525,8 @@
                         if rowcount == -1 or rowcount is None:
                             rowcount = len(cursor.fetchall())
                         if rowcount == len({}.fromkeys(sub_ids)):
-                            self.raise_user_error('access_error',
-                                    self._description)
-                    self.raise_user_error('read_error', self._description)
+                            cls.raise_user_error('access_error', cls.__name__)
+                    cls.raise_user_error('read_error', cls.__name__)
                 res.extend(dictfetchall)
         else:
             res = [{'id': x} for x in ids]
@@ -541,19 +534,19 @@
         for field in fields_pre:
             if field == '_timestamp':
                 continue
-            if getattr(self._columns[field], 'translate', False):
+            if getattr(cls._fields[field], 'translate', False):
                 ids = [x['id'] for x in res]
-                res_trans = translation_obj.get_ids(self._name + ',' + field,
+                res_trans = Translation.get_ids(cls.__name__ + ',' + field,
                     'model', Transaction().language, ids)
                 for i in res:
                     i[field] = res_trans.get(i['id'], False) or i[field]
 
-        for table in self._inherits:
-            field = self._inherits[table]
+        for table in cls._inherits:
+            field = cls._inherits[table]
             inherits_fields = list(
-                    set(self._inherit_fields.keys()).intersection(
+                    set(cls._inherit_fields.keys()).intersection(
                     set(fields_names + fields_related.keys() + datetime_fields)
-                    ).difference(set(self._columns.keys())))
+                    ).difference(set(cls._fields.keys())))
             if not inherits_fields:
                 for record in res:
                     if field not in fields_names + fields_related.keys() + \
